'From Haver 5.0 [latest update: #4572] on 4 May 2021 at 5:32:32 pm'!
'Description '!
!provides: 'Chat' 1 1!
!requires: 'MQTT-Client' 1 12 nil!
SystemOrganization addCategory: 'Chat'!


!moduleCreation: Chat!
Modules newEnvironment: #Chat!

!interfacesOf: Chat!
Modules environment: #Chat ::
	interface: #SPI aliasFor: #API!

!importsOf: Chat!
Modules environment: #Chat :: 
	import: #API of: Modules>>#MQTTClient!

!classDefinition: (Modules>>#Chat>>#AbstractChannel) category: 'Chat'!
Object subclass: #AbstractChannel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#AbstractChannel) class category: 'Chat'!
(Modules>>#Chat>>#AbstractChannel) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Chat>>#Channel) category: 'Chat'!
(Modules>>#Chat>>#AbstractChannel) subclass: #Channel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#Channel) class category: 'Chat'!
(Modules>>#Chat>>#Channel) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Chat>>#AbstractChatter) category: 'Chat'!
Object subclass: #AbstractChatter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#AbstractChatter) class category: 'Chat'!
(Modules>>#Chat>>#AbstractChatter) class
	instanceVariableNames: 'defaultInstance'!

!classDefinition: (Modules>>#Chat>>#MQTTChatter) category: 'Chat'!
(Modules>>#Chat>>#AbstractChatter) subclass: #MQTTChatter
	instanceVariableNames: 'channels users primaryUser mqttClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#MQTTChatter) class category: 'Chat'!
(Modules>>#Chat>>#MQTTChatter) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Chat>>#AbstractMessage) category: 'Chat'!
Object subclass: #AbstractMessage
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#AbstractMessage) class category: 'Chat'!
(Modules>>#Chat>>#AbstractMessage) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Chat>>#AbstractControlMessage) category: 'Chat'!
(Modules>>#Chat>>#AbstractMessage) subclass: #AbstractControlMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#AbstractControlMessage) class category: 'Chat'!
(Modules>>#Chat>>#AbstractControlMessage) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Chat>>#TexttMessage) category: 'Chat'!
(Modules>>#Chat>>#AbstractMessage) subclass: #TexttMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#TexttMessage) class category: 'Chat'!
(Modules>>#Chat>>#TexttMessage) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#Chat>>#User) category: 'Chat'!
Object subclass: #User
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chat'
	inModule: #Chat!
!classDefinition: (Modules>>#Chat>>#User) class category: 'Chat'!
(Modules>>#Chat>>#User) class
	instanceVariableNames: ''!


!(Modules>>#Chat>>#AbstractChannel) commentStamp: '<historical>' prior: 0!
I am the abstract base class of all channels.!

!(Modules>>#Chat>>#Channel) commentStamp: '<historical>' prior: 0!
I am an ordinary channel.!

!(Modules>>#Chat>>#MQTTChatter) commentStamp: '<historical>' prior: 0!
I provide the IP connection for chatting and mange  the users and channels.!

!(Modules>>#Chat>>#AbstractMessage) commentStamp: '<historical>' prior: 0!
I am the abstract base class of all chat messages.!

!(Modules>>#Chat>>#TexttMessage) commentStamp: '<historical>' prior: 0!
I am a text message.!

!(Modules>>#Chat>>#User) commentStamp: '<historical>' prior: 0!
I am the user of a chat.!

!(Modules>>#Chat>>#AbstractChatter) class methodsFor: 'defaults' stamp: 'KLG 4/30/2021 16:49:50'!
default
	"Answer the defaullt  instance of the chatter in teh image"

	^ defaultInstance ifNil: [ defaultInstance _ self new ]! !

!(Modules>>#Chat>>#AbstractChatter) class methodsFor: 'login/logout' stamp: 'KLG 4/30/2021 16:48:10'!
login: aUser
	"Login a user to the chatter."

	self subclassResponsibility! !

!(Modules>>#Chat>>#MQTTChatter) methodsFor: 'instance creation' stamp: 'KLG 4/30/2021 14:20:57'!
mqttClientClass
	"Answer the class of the MQTT client.."

	^ self class mqttClientClass! !

!(Modules>>#Chat>>#MQTTChatter) methodsFor: 'initialization' stamp: 'KLG 4/30/2021 17:58:40'!
initialize
	"Initialize the chatter."

	super initialize.
	mqttClient _ self mqttClientClass new! !

!(Modules>>#Chat>>#MQTTChatter) class methodsFor: 'instance creation' stamp: 'KLG 4/30/2021 14:20:57'!
mqttClientClass
	"Answer the class of the MQTT client.."

	^ MQTTClient ! !

!(Modules>>#Chat>>#MQTTChatter) class methodsFor: 'defaults' stamp: 'KLG 4/30/2021 14:54:46'!
defaultDevelopmentHost
	"Answer the name of the default development host."

	^ '127.0.0.1'! !

!(Modules>>#Chat>>#MQTTChatter) class methodsFor: 'defaults' stamp: 'KLG 4/30/2021 14:53:29'!
defaultHost
	"Answer the name of the default host."

	^ self defaultDevelopmentHost! !

!(Modules>>#Chat>>#MQTTChatter) class methodsFor: 'defaults' stamp: 'KLG 4/30/2021 14:54:35'!
defaultProductionHost
	"Answer the name of the default proudction host."

	^ 'chat.klix.ch'! !

!(Modules>>#Chat>>#MQTTChatter) class methodsFor: 'login/logout' stamp: 'KLG 4/30/2021 16:47:24'!
login: aUser
	"Login a user to the chatter."

	self shouldBeImplemented! !

!(Modules>>#Chat>>#AbstractMessage) methodsFor: 'accessing' stamp: 'KLG 4/30/2021 16:25:32'!
contents
	"Answer the value of contents"

	^ contents! !

!(Modules>>#Chat>>#AbstractMessage) methodsFor: 'accessing' stamp: 'KLG 4/30/2021 16:35:18'!
contents: anObject
	"Set the value of contents"

	self subclassResponsibility! !

!(Modules>>#Chat>>#TexttMessage) methodsFor: 'accessing' stamp: 'KLG 4/30/2021 16:34:58'!
contents: anObject
	"Set the value of contents"

	contents _ anObject asChatTextMessage! !

!Object methodsFor: '*Chat' stamp: 'KLG 4/30/2021 16:32:01'!
asChatTextMessage
	"Convert the object to message suitable for Haver's chat (text) messages."

	^ self asString! !
