'From Haver 6.0 [latest update: #5087] on 9 March 2022 at 9:12:34 pm'!
'Description I provide support for singletons that save a growing and changeing collections of objects.

I am used for journals or simple (address to state) mapping.'!
!provides: 'PersistentObjectCollection' 1 12!
!requires: 'PlanE' 1 46 nil!
SystemOrganization addCategory: 'PersistentObjectCollection'!


!moduleCreation: PersistentObjectCollection!
Modules newEnvironment: #PersistentObjectCollection!

!interfacesOf: PersistentObjectCollection!
Modules environment: #PersistentObjectCollection ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!

!importsOf: PersistentObjectCollection!
Modules environment: #PersistentObjectCollection :: 
	import: #(#PlanE ) from: #API of: Modules>>#PlanE!

!classDefinition: (Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) category: 'PersistentObjectCollection'!
Object subclass: #AbstractPersistentCollection
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentObjectCollection'
	inModule: #PersistentObjectCollection!
!classDefinition: (Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) class category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) subclass: #AbstractPersistentSingletonCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentObjectCollection'
	inModule: #PersistentObjectCollection!
!classDefinition: (Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class
	instanceVariableNames: 'uniqueInstance store'!

!classDefinition: (Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) subclass: #AbstractConcurrentPersistentSingletonCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentObjectCollection'
	inModule: #PersistentObjectCollection!
!classDefinition: (Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class
	instanceVariableNames: 'guard'!

!classDefinition: (Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) subclass: #IndividualPersistentCollection
	instanceVariableNames: 'store storeFilename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentObjectCollection'
	inModule: #PersistentObjectCollection!
!classDefinition: (Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) class category: 'PersistentObjectCollection'!
(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) class
	instanceVariableNames: ''!


!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all persistent collections.!

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all persistent collections that are singletons.!

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all persistent collections that are singletons and provide safe concurrent access.!

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) commentStamp: '<historical>' prior: 0!
I am a class that is able to load arbitrary, especially singleton, persistent collections from a file.
!

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'system startup' stamp: 'KLG 12/16/2021 14:32:16'!
releaseClassCachedState
	"Will be called for each class on shutdown or snapshot.
	All class vars or class instVar vars that can be cheaply recreated lazily on demand, should be nilled.
	For more expensive stuff to clean and recreate, consider #releaseClassState that is not called on every image save.
	See implementors for examples"
	
	self close! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'persistence' stamp: 'KLG 2/24/2022 18:03:59'!
store
	"Answer the store."
	
	^ self subclassResponsibility! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'initialization' stamp: 'KLG 2/24/2022 18:19:40'!
initialize
	"Initialize the elements collection."

	super initialize.
	elements _ self baseCollectionClass new! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'testing' stamp: 'KLG 2/24/2022 18:02:31'!
isEmpty
	"Answer true when I am empty."

	^ elements isEmpty! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:02:43'!
add: anElement 
	"Add anElement to me."
	
	| answer |
	self store begin.
	[ answer _ elements add: anElement ] ifCurtailed: [
		self store abort.
		^ nil ].
	self store commit.
	^ answer! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 20:04:22'!
addAll: aCollection 
	"Add all elements in the collection."
	
	^ elements addAll: aCollection! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:02:52'!
at: anIndex
	"Anser the  elementat at anIndex."
	
	^ elements at: anIndex! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:02:56'!
at: anIndex ifAbsent: aBlock
	"Anser the  elementat at anIndex if not found answer the value of aBlock."
	
	^ elements at: anIndex ifAbsent: aBlock ! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:03:04'!
at: key ifPresent: presentBlock ifAbsent: absentBlock
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."
	
	^ elements at: key ifPresent: presentBlock ifAbsent: absentBlock ! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:03:11'!
at: anIndex put:  anElement 
	"Put anElementat anIndex."
	
	| answer |
	self store begin.
	[ answer _ elements at: anIndex put: anElement ] ifCurtailed: [
		self store abort.
		^ nil ].
	self store commit.
	^ answer! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:03:16'!
collect: aBlock
	"Collect the value of a Block for all elements."

	^ elements collect: aBlock! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:03:25'!
do: aBlock
	"Evaluate aBlock for every element."

	elements do: aBlock! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'accessing' stamp: 'KLG 2/24/2022 18:03:30'!
size
	"Answer my size."

	^ elements size! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) methodsFor: 'instance creation' stamp: 'KLG 2/24/2022 17:59:50'!
baseCollectionClass
	"Answer the base collection class."

	^ self class baseCollectionClass	! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) class methodsFor: 'instance creation' stamp: 'KLG 2/24/2022 18:00:05'!
baseCollectionClass
	"Answer the base collection class.
	
	May be overidden in subclasses."

	^ OrderedCollection! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) class methodsFor: 'instance creation' stamp: 'KLG 2/26/2022 14:11:11'!
storeClass
	"Answer the store class.."

	^ PlanE! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentCollection) class methodsFor: 'open/close' stamp: 'KLG 2/25/2022 19:28:48'!
close
	"Close the collection."

	self subclassResponsibility! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) methodsFor: 'persistence' stamp: 'KLG 12/16/2021 13:43:22'!
store
	"Answer the gflobal store."
	
	^ self class store! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'open/close' stamp: 'KLG 12/16/2021 13:29:46'!
close
	"Close the collection."

	store ifNotNil: [ 
		[ store close ] on: Error do: [].
		uniqueInstance _ store _ nil ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'persistence' stamp: 'KLG 12/15/2021 20:40:36'!
store
	"Answer the store to use."

	^ store ifNil: [ store _ self storeClass openOn: self storeFilename ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'persistence' stamp: 'KLG 12/15/2021 20:41:09'!
storeFilename
	"Answer the filename of the store."

	^ self subclassResponsibility! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'instance creation' stamp: 'KLG 12/15/2021 20:39:06'!
uniqueInstance
	"Answer our unique instance."

	^ uniqueInstance ifNil: [
		uniqueInstance _ self store root ifNil: [ | answer | 
			self store		begin.
			self store root: (answer _ self new).
			self store 	commit.
			^ answer ] ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 15:28:41'!
add: anItem
	"Add anItem."

	^ self uniqueInstance add: anItem! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 22:18:13'!
at: anIndex
	"Answer the lement at an index."

	^ self uniqueInstance at: anIndex! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 22:17:30'!
at: anIndex ifAbsent: aBlock
	"Anser the  elementat at anIndex if not found answer the value of aBlock."
	
	^ self uniqueInstance at: anIndex ifAbsent: aBlock! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/19/2021 23:22:08'!
at: key ifPresent: presentBlock ifAbsent: absentBlock
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."
	
	^ self critical: [ self uniqueInstance at: key ifPresent: presentBlock ifAbsent: absentBlock ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/17/2021 15:20:23'!
at: anIndex put: anItem
	"Put anItem at anIndex."

	^ self uniqueInstance at: anIndex put: anItem! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/15/2021 20:46:12'!
collect: aBlock
	"Collect the value of aBlock for every element."

	^ self uniqueInstance collect: aBlock! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/15/2021 20:47:40'!
do: aBlock
	"Collect the value of aBlock for every element."

	self uniqueInstance do: aBlock! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/15/2021 20:44:05'!
elements
	"Answer the elements of the collection."

	^ self uniqueInstance elements! !

!(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) class methodsFor: 'concurrency' stamp: 'KLG 12/15/2021 20:36:27'!
critical: aBlock
	"Evaluate aBlo9ck in a crtitical section and answer the result.
	
	Simply evaluate aBlock, we do not support concurrent access."

	^ aBlock value! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'class initialization' stamp: 'KLG 12/15/2021 20:34:04'!
initialize
	"Initialize the guard."

	guard _ Mutex new! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'concurrency' stamp: 'KLG 12/16/2021 12:14:01'!
critical: aBlock
	"Evaluate aBlo9ck in a crtitical section and answer the result."

	^ guard ifNil: [ guard _ Mutex new ] :: critical: aBlock ! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 12:14:26'!
add: anItem
	"Add anItem."

	^ self critical: [ self uniqueInstance add: anItem ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 22:13:56'!
at: anIndex
	"Answer the lement at an index."

	^ self critical: [ self uniqueInstance at: anIndex ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 22:19:17'!
at: anIndex ifAbsent: aBlock
	"Anser the  elementat at anIndex if not found answer the value of aBlock."
	
	^ self critical: [ self uniqueInstance at: anIndex ifAbsent: aBlock ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 2/26/2022 14:15:51'!
at: anIndex put: anItem
	"Put anItem at anIndex."

	^ self critical: [ self uniqueInstance at: anIndex put: anItem ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/15/2021 20:52:05'!
collect: aBlock
	"Collect the value of aBlock for every element."

	^ self uniqueInstance collect: [		:element |
		self critical: [ aBlock value: element ] ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/15/2021 20:51:12'!
do: aBlock
	"Evaluate aBlock for every element."

	self uniqueInstance do: [ :element |
		self critical: [ aBlock value: element ] ]! !

!(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) class methodsFor: 'accessing' stamp: 'KLG 12/15/2021 20:44:36'!
elements
	"Answer the elements of the collection."

	^ self uniqueInstance collect: [ :element | element ]! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) methodsFor: 'initialization' stamp: 'KLG 2/24/2022 19:42:19'!
on: aFilename
	"Deferr opening my store until my elements are accessed."	

	self assert: store isNil.
	storeFilename _ aFilename! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) methodsFor: 'persistence' stamp: 'KLG 2/24/2022 19:35:25'!
store
	"Answer my store."

	^ store ifNil: [
		store _ self storeClass openOn: self storeFilename ]! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) methodsFor: 'persistence' stamp: 'KLG 2/24/2022 19:37:14'!
storeFilename
	"Answer the filename of the store."

	self assert: storeFilename notNil.
	^ storeFilename! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) methodsFor: 'instance creation' stamp: 'KLG 2/24/2022 19:36:11'!
storeClass
	"Answer the class of store to use."
	
	^ self class storeClass! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) methodsFor: 'open/close' stamp: 'KLG 2/24/2022 19:47:28'!
close
	"Close the collection."
	
	store ifNotNil: [ 
		store close.
		store _ nil ]! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) methodsFor: 'open/close' stamp: 'KLG 2/24/2022 19:59:44'!
openOn: aFilename
	"Open me on a aFilename."

	self assert: store isNil.
	self assert: storeFilename isNil.
	self on: aFilename.
	(store _ self storeClass openOn: aFilename)		root
		ifNil: [ store root: elements ]
		ifNotNil: [ elements _ store root ]
	! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) class methodsFor: 'open/close' stamp: 'KLG 2/24/2022 19:44:38'!
openOn: aFilename
	"Create a ne instance of mine and and openi the store. "

	^ self new openOn: aFilename; yourself! !

!(Modules>>#PersistentObjectCollection>>#IndividualPersistentCollection) class methodsFor: 'instance creation' stamp: 'KLG 2/24/2022 19:44:22'!
on: aFilename
	"Create a ne instance of mine and deferr opening the store. "

	^ self new on: aFilename; yourself! !
(Modules>>#PersistentObjectCollection>>#AbstractConcurrentPersistentSingletonCollection) initialize!
