'From Haver 6.0 [latest update: #5094] on 2 April 2022 at 2:37:52 pm'!
'Description I contain all the subclasses Haver uses to customize the built in Cuis complier.

The current goal could have been achieved by hacking UndeclaredVariable,
but let''s do it properly without hacking.

And there is still the idea of using environment local symbols to provide real private/protected/module-internal methods.'!
!provides: 'HaverCompiler' 1 14!
!requires: 'ModulesTools' 1 27 nil!
!requires: 'Modules' 1 91 nil!
SystemOrganization addCategory: 'HaverCompiler'!


!moduleCreation: HaverCompiler!
Modules newEnvironment: #HaverCompiler!

!interfacesOf: HaverCompiler!
Modules environment: #HaverCompiler ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!

!importsOf: HaverCompiler!
Modules environment: #HaverCompiler :: 
	import: #(#ModuleBrowser ) from: #SPI of: Modules>>#ModulesTools!

!classDefinition: (Modules>>#HaverCompiler>>#UndeclaredVariable) category: 'HaverCompiler'!
UndeclaredVariable subclass: #UndeclaredVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HaverCompiler'
	inModule: #HaverCompiler!
!classDefinition: (Modules>>#HaverCompiler>>#UndeclaredVariable) class category: 'HaverCompiler'!
(Modules>>#HaverCompiler>>#UndeclaredVariable) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#HaverCompiler>>#HaverCompiler) category: 'HaverCompiler'!
Compiler subclass: #HaverCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HaverCompiler'
	inModule: #HaverCompiler!
!classDefinition: (Modules>>#HaverCompiler>>#HaverCompiler) class category: 'HaverCompiler'!
(Modules>>#HaverCompiler>>#HaverCompiler) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#HaverCompiler>>#HaverParser) category: 'HaverCompiler'!
Parser subclass: #HaverParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HaverCompiler'
	inModule: #HaverCompiler!
!classDefinition: (Modules>>#HaverCompiler>>#HaverParser) class category: 'HaverCompiler'!
(Modules>>#HaverCompiler>>#HaverParser) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#HaverCompiler>>#ExportImportWizard) category: 'HaverCompiler'!
Object subclass: #ExportImportWizard
	instanceVariableNames: 'exception selectedNameProvider selectedInterface abort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HaverCompiler'
	inModule: #HaverCompiler!
!classDefinition: (Modules>>#HaverCompiler>>#ExportImportWizard) class category: 'HaverCompiler'!
(Modules>>#HaverCompiler>>#ExportImportWizard) class
	instanceVariableNames: ''!


!(Modules>>#HaverCompiler>>#UndeclaredVariable) commentStamp: '<historical>' prior: 0!
I am the parser's notification for undeclared variables.!

!(Modules>>#HaverCompiler>>#HaverCompiler) commentStamp: '<historical>' prior: 0!
I am the Haver specific compiler.!

!(Modules>>#HaverCompiler>>#HaverParser) commentStamp: '<historical>' prior: 0!
I am the Haver specific parser class.!

!(Modules>>#HaverCompiler>>#ExportImportWizard) commentStamp: '<historical>' prior: 0!
I am a wizard to export and import undeclared (global) variables from modules providing them.

I try to make smart decisions about the module and the interface to use.

All the necessary information is in the exception!

!(Modules>>#HaverCompiler>>#HaverCompiler) class methodsFor: 'accessing' stamp: 'KLG 5/4/2021 19:36:14'!
parserClass
	"Answer a parser class to use for parsing methods compiled by instances of the receiver."

	^ HaverParser! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) methodsFor: 'class' stamp: 'KLG 5/4/2021 20:35:14'!
classToActOn
	"Answer the class we are acting on."

	^ parser encoder classEncoding! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) methodsFor: 'instance creation' stamp: 'KLG 5/6/2021 14:54:11'!
exportImportWizardClass
	"Answer the class of the export/import wizard."

	^ self class exportImportWizardClass! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) methodsFor: 'exception handling' stamp: 'KLG 5/8/2021 13:46:28'!
defaultAction
	"Try to fix the problem by importing the proper name."
	
	self exportImportWizardClass tryToFixThisError: self ::
		ifNotNil: [ :action | 
			action == #default
				ifTrue: [ super defaultAction ]
				ifFalse: [ self resume: action ] ]
		ifNil: [ self resume: nil ]
	! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) methodsFor: 'error handling' stamp: 'KLG 5/6/2021 17:42:34'!
encodeTheVariable
	"Tell the parser's encoder to just encode the variable,
	it is declared now."

	^ parser encoder encodeVariable: self name! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) methodsFor: 'error handling' stamp: 'KLG 5/8/2021 12:56:48'!
renameTheVariableTo: aNewName
	"Rename the varibale to aNewName."
	
	^ parser substituteVariable: aNewName atInterval: interval
	! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) methodsFor: 'error handling' stamp: 'KLG 5/8/2021 12:12:55'!
reparse
	"Trigger the reparsing of the source code."
	
	ReparseAfterSourceEditing signal
	! !

!(Modules>>#HaverCompiler>>#UndeclaredVariable) class methodsFor: 'instance creation' stamp: 'KLG 5/6/2021 14:52:13'!
exportImportWizardClass
	"Answer the class of the export/import wizard."

	^ ExportImportWizard ! !

!(Modules>>#HaverCompiler>>#HaverCompiler) class methodsFor: 'class initialization' stamp: 'KLG 5/9/2021 21:22:48'!
initialize
	"Add me to the compiler's Refactoring is able to work on."


	Refactoring addAllowedToRefactorClassCompiler: self! !

!(Modules>>#HaverCompiler>>#HaverParser) methodsFor: 'error correction' stamp: 'KLG 5/4/2021 20:07:47'!
correctVariable: proposedVariable interval: aSpot
	"Correct the proposedVariable to a known variable, or declare it as a new
	variable if such action is requested.  We support declaring lowercase
	variables as temps or inst-vars, and uppercase variables as Globals or 
	ClassVars, depending on whether the context is nil (class=UndefinedObject).
	Spot is the interval within the test stream of the variable.
	rr 3/4/2004 10:26 : adds the option to define a new class. "

	"Check if this is an i-var, that has been corrected already (ugly)"

	"Display the pop-up menu"

	| userSelection action delta spot |
	(encoder classEncoding instVarNames includes: proposedVariable) ifTrue: [
		^InstanceVariableNode new 
			name: proposedVariable
			index: (encoder classEncoding allInstVarNames indexOf: proposedVariable)].

	"First check to see if the requestor knows anything about the variable"
	(requestor bindingOf: proposedVariable)
		ifNotNil: [ :binding | ^ encoder global: binding name: proposedVariable].

	"If we can't ask the user for correction, make it undeclared"
	self interactive ifFalse: [^encoder undeclared: proposedVariable].

	userSelection _ requestor selectionInterval.
	delta _ self sourceDelta.
	spot _ aSpot first - delta to: aSpot last - delta.
	requestor selectFrom: spot first to: spot last.

	"Build the menu with alternatives"
	action _ UndeclaredVariable 
				signalFor: self
				name: proposedVariable
				inRange: spot.
	action ifNil: [^self fail].

	Transcript
		newLine;
		show: action;
		newLine;
		show: proposedVariable.

	"Execute the selected action"
	requestor selectInvisiblyFrom: userSelection first to: userSelection last.
	^action value ifNil: [self fail].
	! !

!(Modules>>#HaverCompiler>>#HaverParser) methodsFor: 'expression types' stamp: 'KLG 5/4/2021 23:29:15'!
messagePart: level repeat: repeat

	| start receiver selector args precedence words keywordStart |
	
	self flagHaver: 'TODO: Support access levels for non keyword messages'.
	[receiver := parseNode.
	(hereType == #keyword and: [level >= 3])
		ifTrue: 
			[start := self startOfNextToken.
			selector := WriteStream on: (String new: 32).
			args := OrderedCollection new.
			words := OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[keywordStart := self startOfNextToken + requestorOffset.
					selector nextPutAll: self advance.
					words addLast: (keywordStart to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 2 repeat: true.
					args addLast: parseNode].
			(self findSelector: selector ifFound:  [ :sym | selector := sym])
				ifFalse: [ selector := self correctSelector: selector contents
										wordIntervals: words
										exprInterval: (start to: self endOfLastToken)
										ifAbort: [ ^ self fail ] ].
			precedence := 3]
		ifFalse: [
			
			level >= 2 ifTrue: [self transformVerticalBarAndUpArrowIntoABinarySelector].
			((hereType == #binary )
				and: [level >= 2])
				ifTrue: 
					[start := self startOfNextToken.
					selector := self advance asSymbol.
					words := OrderedCollection with: (start  + requestorOffset to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 1 repeat: true.
					args := Array with: parseNode.
					precedence := 2]
				ifFalse: [hereType == #word
						ifTrue: 
							[start := self startOfNextToken.
							selector := self advance.
							args := #().
							words := OrderedCollection with: (start  + requestorOffset to: self endOfLastToken + requestorOffset).
							(self findSelector: selector ifFound: [ :sym | selector := sym])
								ifFalse: [ selector := self correctSelector: selector
													wordIntervals: words
													exprInterval: (start to: self endOfLastToken)
													ifAbort: [ ^ self fail ] ].
							precedence := 1]
						ifFalse: [^args notNil]]].

	parseNode := MessageNode new
				receiver: receiver
				selector: selector
				arguments: args
				precedence: precedence
				from: encoder
				sourceRange: (start to: self endOfLastToken)
				keywordsRanges: words.
	repeat]
		whileTrue: [].
	^true! !

!(Modules>>#HaverCompiler>>#HaverParser) methodsFor: 'access levels' stamp: 'KLG 5/8/2021 11:14:57'!
findSelector: aSelectorStream ifFound: aBlock
	"Find aSelector "

	| symbolString symbol metaclass |
	"This needs to be done before the remaining steps, because 
	the code below interns the symbol:"
	Symbol hasInterned: (symbolString _ aSelectorStream contents)
		ifTrue: [ :sym | 
			aBlock value: sym ] ::
		"All private and internal selectors are interned symbols, 
		therefore we can quit, if we find no interned symbol.
		Acutally we have to quit, otherwise we will intern an undefined
		selector. which makes it appear twice in the correction menu:"
		ifFalse: [ ^ false ].
	symbol _  symbolString asSymbol.
	metaclass _ encoder classEncoding theMetaClass.
	metaclass privateSelectors includes: symbol :: ifTrue:		[ | sym |
		sym _ metaclass privateSelectorFor: symbol.
		Transcript
			newLine;
			show: 'private selector: ';
			show: sym.
		aBlock value: sym.
		^ true ].
	metaclass environment internalSelectors includes: symbol ::
		ifTrue: [ | sym |
			sym _ metaclass internalSelectorFor: symbol.
			Transcript
				newLine;
				show: 'internal selector: ';
				show: sym.
			aBlock value: sym.
			^ true ].
	^ true 
! !

!(Modules>>#HaverCompiler>>#HaverParser) methodsFor: 'primitives' stamp: 'KLG 5/12/2021 17:33:02'!
externalType: descriptorClass
	"Parse an return an external type"
	| xType |
	xType := descriptorClass atomicTypeNamed: here.
	xType == nil ifTrue:["Look up from class scope"
		Symbol hasInterned: here ifTrue:[:sym|
			xType := descriptorClass structTypeNamed: sym]].
	xType == nil ifTrue: [ | localSymbol |
		localSymbol _ SymbolManager
			ensureSymbol: here
			forEnvironment: encoder classEncoding class environment.
			xType _ descriptorClass structTypeNamed: localSymbol ].
	xType == nil ifTrue:[
		"Raise an error if user is there"
		self interactive ifTrue:[^nil].
		"otherwise go over it silently"
		xType := descriptorClass forceTypeNamed: here].
	self advance.
	(self matchToken:#*)
		ifTrue:[^xType asPointerType]
		ifFalse:[^xType]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/4/2021 20:37:15'!
classToActOn
	"Answer the class we are acting on."

	^ exception classToActOn! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/6/2021 16:49:40'!
environment
	"Answer the environment to work on.
	
	Environment is always a module."

	^ self classToActOn theMetaClass environment! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/4/2021 20:45:16'!
exception
	"Answer the value of exception"

	^ exception! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/4/2021 20:45:33'!
exception: anObject
	"Set the value of exception"

	self assert: exception isNil.
	exception _ anObject! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/4/2021 20:44:52'!
nameToCorrect
	"Answer the name to correct."

	^ exception name! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/8/2021 13:22:45'!
selectedNameProvider: anExportSpecificationOrBoth
	"Set the selected name provider."

	anExportSpecificationOrBoth isArray
		ifTrue: [
			selectedNameProvider _ anExportSpecificationOrBoth first.
			selectedInterface _ anExportSpecificationOrBoth second ]
		ifFalse: [
			selectedNameProvider _ anExportSpecificationOrBoth ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'accessing' stamp: 'KLG 5/8/2021 13:39:27'!
setAbort
	"Ste the abort flag."

	abort _ true! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling' stamp: 'KLG 12/8/2021 18:26:00'!
tryToFixTheError
	"As the name says try to fix the error by employing various strategies.
	
	Answer true if we installed a fix for the missing name."

	#(fixUndeclared fixByExportedName fixByRenamedExport fixByInternalBinding) do: [ :fixupSelector |
		self perform: fixupSelector :: ifNotNil: [ : action | ^ action ].
		abort ifTrue: [ ^ nil ] ].
	^ #default! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - fix undeclared' stamp: 'KLG 3/31/2022 15:13:35'!
fixUndeclared
	"Try to fix the problem bt recompiling the module."
	
	self flagHaver:
		'This is a kludge!!
		This might happens because we do not have a proper undeclared handling!!'.

	self classToActOn theMetaClass environment
		at: exception name asSymbol
		ifPresent: [ :environment |
			environment compileAll.
			"O: self halt: 'Check for recursion!!'."
			^ [ exception encodeTheVariable ] ].
	^ nil! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - exact export' stamp: 'KLG 5/8/2021 14:18:57'!
askTheUserForAnExactExport
	"Ask the user to select an interface with the exact export. "

	| menu exportingModule |
	selectedNameProvider _  selectedInterface _ nil.
	menu _ (self menuMorphClass new)
		addTitle: 'Interfaces exporting: ', self nameToCorrect.
	self doNameInExportSpecifications: [ :exportSpec :interface |
		exportingModule
			 ifNotNil: [ | mayBeNewModule |
				exportingModule == (mayBeNewModule _ interface owner) ifFalse: [
					exportingModule _ mayBeNewModule 
					menu addTitle: 'Module: ', exportingModule name ] ]
			ifNil: [
				exportingModule _ interface owner.
				menu addTitle: 'Module: ', exportingModule name].
		menu 
			add: interface name
			target: self
			action: #selectedNameProvider:
			argument: {exportSpec. interface} ].
	"No module seen, so don't ask:".
	exportingModule ifNil: [ ^ false ].
	self appendControlMenuOptions: menu.
	menu invokeModal.
	^ selectedNameProvider notNil! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - exact export' stamp: 'KLG 5/8/2021 13:29:16'!
fixByExportedName
	"Try to find an exported name let the user choose and  if OKimport exactly that symbol."

	^ self askTheUserForAnExactExport
		ifTrue: [
			self 
				importExactExport: selectedNameProvider
				fromInterface: selectedInterface.
			self doForAllModulBrowsers: [ :moduleBrowser |
				moduleBrowser 
					changed: #importListItems;
					changed: #importAllButtonText ].
			[ exception encodeTheVariable ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - exact export' stamp: 'KLG 5/8/2021 13:27:46'!
importExactExport: anExportSpecification fromInterface: anInterface
	"Import anExportSpecification without any renaming."
	
	| importInterfaceResult |
	importInterfaceResult _ self environment importFrom: anInterface.
	^ importInterfaceResult second addExplicitImportAndAnswerIt: anExportSpecification.! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - renamed export' stamp: 'KLG 5/8/2021 14:24:16'!
askTheUserForARenamedExport
	"Ask the user to select an interface with a renamed export. "

	| menu exportingModule |
	selectedNameProvider _ selectedInterface _ nil.
	menu _ (self menuMorphClass new)
		addTitle: 'Modules exporting renamed:', self nameToCorrect.
	self doNameInRenamedExportSpecifications: [ :exportSpec :interface |
		exportingModule
			 ifNotNil: [ | mayBeNewModule |
				exportingModule == (mayBeNewModule _ exportSpec owner owner) ifFalse: [
					exportingModule _ mayBeNewModule 
					menu addTitle: 'Module: ', exportingModule name ] ]
			ifNil: [
				exportingModule _ exportSpec owner owner.
				menu addTitle: 'Module: ', exportingModule name].
		menu 
			add: (String streamContents: [ :stream |
					stream
						nextPutAll: interface name;
						nextPutAll: ' (';
						nextPutAll: exportSpec name;
						nextPut:$) ])
			target: self
			action: #selectedNameProvider:
			argument: { exportSpec. interface }].
	"We did not see any module, so don't ask:"
	exportingModule ifNil: [ ^ false ].
	self appendControlMenuOptions: menu.
	menu invokeModal.
	^ selectedNameProvider notNil! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - renamed export' stamp: 'KLG 5/8/2021 12:52:32'!
askTheUserForRenameOnImport
	"Ask the user whther we should rename the import or change the sorce code."

	^ PopUpMenu
		confirm: 'How to rename?'
		trueChoice: 'Rename on import'
		falseChoice: 'Rename in method source code'! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - renamed export' stamp: 'KLG 5/8/2021 14:26:13'!
fixByRenamedExport
	"Try to find an exported name with a matchin internal name
	let the user choose and  if OKimport exactly that symbol."

	^ self askTheUserForARenamedExport 
		ifTrue: [ | renameOnImport |
			(renameOnImport _ self askTheUserForRenameOnImport)
				ifTrue: [ 
					self 
						importRenamedExport: 	selectedNameProvider
						fromInterface: selectedInterface ]
				ifFalse: [ 
					self
						importExactExport: selectedNameProvider
						fromInterface: selectedInterface ].
			self doForAllModulBrowsers: [ :moduleBrowser |
				moduleBrowser 
					changed: #importListItems;
					changed: #importAllButtonText ].
			renameOnImport 
				ifTrue: 	[ [ exception encodeTheVariable ] ]
				ifFalse: [ [ exception renameTheVariableTo: selectedNameProvider name ] ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - renamed export' stamp: 'KLG 5/8/2021 14:12:17'!
importRenamedExport: anExportSpecification fromInterface: anInterface
	"Import anExportSpecification with a matching internal name be renaming it back
	to its module internal name.."
	
	^ self 
		importExactExport: anExportSpecification
		fromInterface: anInterface :: 
			name: self nameToCorrect asSymbol! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - bound symbols' stamp: 'KLG 5/8/2021 21:06:09'!
askTheUserForAnInterfaceToAddAnExport: aModule 
	"Ask the user for anInterface to add the export to."
	
	| interfaces menu |
	(interfaces _ aModule interfaces) ifEmpty: [
		| newInterfaceName |
		newInterfaceName _ self newInterfaceName.
		aModule newInterface: newInterfaceName.
		selectedInterface _ aModule interfaceNamed: newInterfaceName.
		^ true ].
	interfaces size = 1 ifTrue: [ 
		selectedInterface _ interfaces anyOne.
		^ true ].
	menu _ (self menuMorphClass new)
		addTitle: 'Interface for exporting'.
	interfaces do: [ :interface |
		menu			
			add: interface name
			target: self
			action: #selectedNameProvider: 
			argument: {aModule. interface} ].
	self addAbortOption: menu.
	menu invokeModal.
	^ selectedNameProvider notNil! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - bound symbols' stamp: 'KLG 5/8/2021 17:03:16'!
askTheUserForAnInternalBinding
	"Ask the user to select a module that has the name bound. "

	| menu moduleSeen nameToCorrect |
	selectedNameProvider _ selectedInterface _ nil.
	nameToCorrect _ self nameToCorrect.
	menu _ (self menuMorphClass new)
		addTitle: 'Modules binding:', nameToCorrect.
	moduleSeen _ false.
	self doNameInModules:  [ :name :module |
		moduleSeen _ true.
		menu
			add: module name
			target: self
			action: #selectedNameProvider: 
			argument: module ]
		selectingBlock: [ :name |
			name = nameToCorrect ].
	"We did not see any module, so don't ask:"
	moduleSeen ifFalse: [ ^ false ].
	self appendControlMenuOptions: menu.
	menu invokeModal.
	^ selectedNameProvider notNil! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - bound symbols' stamp: 'KLG 5/8/2021 20:59:49'!
fixByInternalBinding
	"Fix the error by exporting and then importing an internal binding."
	
	^ self askTheUserForAnInternalBinding
		ifTrue: [ 
			self askTheUserForAnInterfaceToAddAnExport: selectedNameProvider :: 
				ifTrue: [
					selectedInterface ifNil: [
						abort _ true.
						^ nil ].
					self 
						importExactExport: 
							(selectedInterface addExportedSymbol: self nameToCorrect asSymbol)
						 fromInterface:
							selectedInterface .
					self doForAllModulBrowsers: [ :moduleBrowser |
						moduleBrowser
							changed: #interfaceListItems;
							changed: #importListItems;
							changed: #importAllButtonText ].
					[ exception encodeTheVariable ] ]
				ifFalse: [ #default ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'error handling - bound symbols' stamp: 'KLG 5/8/2021 21:19:19'!
newInterfaceName
	"Ansertwthe name a new interface to create,"

	
	self classToActOn inheritsFrom: TestCase ::
		or: [ self classToActOn inheritsFrom: TestResource ] ::
		ifTrue: [ ^ #UTI ].
	self classToActOn withAllSuperclassesDo: [ :class |
		class name environment == self environment ifTrue: [ ^ #SPI ] ].
	^ #API	! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'finding' stamp: 'KLG 5/6/2021 13:26:00'!
doNameInExportSpecifications: aBlock
	"Execute aBlock for every export specification that exactly matches the missing name."

	| nameToCorrect |
	nameToCorrect _ self nameToCorrect.
	self doNameInExportSpecifications: aBlock selectingBlock: [ :exportSpec |
		exportSpec name = nameToCorrect ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'finding' stamp: 'KLG 5/8/2021 13:18:36'!
doNameInExportSpecifications: aBlock selectingBlock: aSelectingBlock
	"Execute aBlock for all export specifications aSelectingBlock evaluates to true."

	Modules environments do: [ :module |
		module interfaces do: [ :interface |
			interface exportSpecifications do: [ :exportSpec |
				aSelectingBlock value: exportSpec :: ifTrue: [
					aBlock 
						valueWithPossibleArgument: exportSpec
						and: interface ] ] ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'finding' stamp: 'KLG 5/8/2021 16:45:34'!
doNameInModules: aBlock selectingBlock: aSelectingBlock
	"Execute aBlock for all modules aSelectingBlock evaluates to true."

	Modules environments do: [ :module |
		module keysDo: [ :boundName |  | boundNameString |
			aSelectingBlock value: (boundNameString _ boundName asString) :: ifTrue: [
				aBlock valueWithPossibleArgument: boundNameString and: module ] ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'finding' stamp: 'KLG 5/8/2021 14:21:50'!
doNameInRenamedExportSpecifications: aBlock
	"Execute aBlock for all export specifications that have an internal name equal to the missing name."

	| nameToCorrect |
	nameToCorrect _ self nameToCorrect.
	self doNameInExportSpecifications: aBlock selectingBlock: [ :exportSpec |
		exportSpec name ~= nameToCorrect and: [
			exportSpec internalName = nameToCorrect ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'instance creation' stamp: 'KLG 5/6/2021 13:56:24'!
menuMorphClass
	"Answer the class of a menu moprh."

	^ self class menuMorphClass! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'user interface support' stamp: 'KLG 5/8/2021 20:10:44'!
addAbortOption: aMenu
	"Add the abort option to aMenu."

	^ aMenu 
		add: 'cancel' 
			target: self
			action: #setAbort
			icon: #cancelIcon! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'user interface support' stamp: 'KLG 5/8/2021 14:18:13'!
addMoreOption: aMenu
	"Add the abort option to aMenu."

	^ aMenu 
		add: 'more' 
			target: self
			action: #yourself
			 icon: #listAddIcon! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'user interface support' stamp: 'KLG 5/8/2021 13:58:43'!
appendControlMenuOptions: aMenu

	aMenu addLine.
	 self 
		addAbortOption: aMenu;
		addMoreOption: aMenu! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'user interface support' stamp: 'KLG 5/7/2021 11:32:13'!
doForAllModulBrowsers: aBlock
	"Execute a bBlock for all module browsers."

	self runningWorld allMorphsDo: [ :morph |
		morph is: #SystemWindow :: ifTrue: [
			morph model isKindOf: ModuleBrowser :: ifTrue: [ aBlock value: morph model ] ] ]! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) methodsFor: 'initialization' stamp: 'KLG 5/8/2021 13:38:25'!
initialize
	"Set the abort flag to false."

	super initialize.
	abort _ false! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) class methodsFor: 'instance creation' stamp: 'KLG 5/4/2021 20:47:12'!
forException: anException
	"Answer a new wizard for anException."

	^ self new exception: anException! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) class methodsFor: 'instance creation' stamp: 'KLG 5/6/2021 13:56:52'!
menuMorphClass
	"Answer the class of a menu moprh."

	^ MenuMorph ! !

!(Modules>>#HaverCompiler>>#ExportImportWizard) class methodsFor: 'error handling' stamp: 'KLG 5/6/2021 17:32:27'!
tryToFixThisError: anExcrption
	"As the name says try to fix the error by employing various strategies.
	
	Answer true if we installed a fix for the missing name."

	^ self forException: anExcrption :: tryToFixTheError! !

!Class methodsFor: '*HaverCompiler-instance creation' stamp: 'KLG 5/4/2021 19:50:57'!
compilerClass
	"Answer a compiler class appropriate for source methods of this class."

	^ self class compilerClass! !

!(Environments>>#Modules>>#ModulesMetaclass) methodsFor: '*HaverCompiler-instance creation' stamp: 'KLG 5/4/2021 19:54:56'!
compilerClass
	"Answer a compiler class appropriate for source methods of this class."

	^ `Modules >> #HaverCompiler >> #HaverCompiler`! !
(Modules>>#HaverCompiler>>#HaverCompiler) initialize!
