'From Haver 5.0 [latest update: #4985] on 29 November 2021 at 7:47:38 am'!
'Description I contain buttons that are used in Haver.'!
!provides: 'Buttons' 1 4!
!requires: 'Cuis-Base' 50 4689 nil!
SystemOrganization addCategory: 'Buttons'!


!moduleCreation: Buttons!
Modules newEnvironment: #Buttons!

!interfacesOf: Buttons!
Modules environment: #Buttons ::
	interface: #API exporting: #(#PluggableButtonMorph ) ::
	interface: #UTI aliasFor: #API ::
	interface: #SPI aliasFor: #API!


!classDefinition: (Modules>>#Buttons>>#PluggableButtonMorph) category: 'Buttons'!
PluggableButtonMorph subclass: #PluggableButtonMorph
	instanceVariableNames: 'target labelSelector enabledSelector isEnabled enabledArguments getStateSelectorArguments actionArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Buttons'
	inModule: #Buttons!
!classDefinition: (Modules>>#Buttons>>#PluggableButtonMorph) class category: 'Buttons'!
(Modules>>#Buttons>>#PluggableButtonMorph) class
	instanceVariableNames: ''!


!(Modules>>#Buttons>>#PluggableButtonMorph) commentStamp: '<historical>' prior: 0!
I am a PlugghableButtonMorph that can be disabled and displays it's icon left of it's label.
Also the label will be retrieveable with a selector.!

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'geometry' stamp: 'KLG 6/18/2021 10:28:38'!
minimumExtent
	"Answer the minimum extent."

	| minmumLabelWidth |
	minmumLabelWidth _ 10.
	label ifNotEmpty: [ :nonEmptyLabel |
		[ self owner isColumn ] onDNU: #isColumn do: [ false ] :: ifTrue: [
			minmumLabelWidth _ self fontToUse widthOfString: nonEmptyLabel ] ].
	^ self magnifiedIcon
		ifNotNil:  [ :bigIcon |
			super minimumExtent + bigIcon extent + (minmumLabelWidth @  0) ]
		ifNil: [ super minimumExtent ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'updating' stamp: 'KLG 6/18/2021 10:28:38'!
update: aSymbol

	aSymbol caseOf: {
		[ labelSelector ] -> [ label _ nil. self updateLabelFormModel; redrawNeeded ].
		[ enabledSelector ] -> [ isEnabled _ nil. self redrawNeeded ] }
	otherwise: [ 	super update: aSymbol ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'updating' stamp: 'KLG 6/18/2021 10:28:38'!
updateLabelFormModel
	"Update the lable form the model."

	labelSelector ifNotNil: [ label ifNil: [ label _ self model perform: labelSelector ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 6/18/2021 10:28:38'!
drawDisabledIndicationOn: aCanvas
	"Drawn a diabled indication."
	
	self isEnabled ifFalse: [ 
		aCanvas 
			roundRect: (self morphLocalBounds insetBy: `1@3`) 
			color: `(Color black alpha: 0.5)` 
			radius: Theme current roundedButtonRadius ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 6/18/2021 10:28:38'!
drawEmbossedLabelOn: aCanvas

	| availableW center colorForLabel f l labelMargin targetSize w x y |
	self updateLabelFormModel.
	self magnifiedIcon
		ifNil: [ super drawEmbossedLabelOn: aCanvas ]
		ifNotNil: [ :bigIcon |
			label ifNotNil: [ | iconWidth |
				colorForLabel _ Theme current buttonLabel.
				self isPressed
					ifFalse: [
						self mouseIsOver
							ifFalse: [ colorForLabel _ colorForLabel adjustSaturation: -0.10 brightness: 0.10 ]]
					ifTrue: [ colorForLabel _ colorForLabel adjustSaturation: 0.0 brightness: -0.07 ].
				f _ self fontToUse.
				center _ extent // 2.
				center _ (center x + ((iconWidth _ bigIcon width) / 2)) @ center y.
				labelMargin _ 3.
				w _ f widthOfString: label.
				availableW _ extent x - labelMargin - labelMargin - iconWidth.
				availableW >= w
					ifTrue: [
						l _ label ]
					ifFalse: [
						x _ labelMargin.
						targetSize _ label size * availableW // w.
						l _ label squeezedTo: targetSize.
						(f widthOfString: l) > availableW ifTrue: [
							targetSize _ targetSize - 1.
							l _ label squeezedTo: targetSize ]].
				
				w _ f widthOfString: l.
				x _ center x - (w // 2).
				y _ center y - (f lineSpacing // 2).
				aCanvas
					drawString: l
					at: x@y
					font: f
					color: colorForLabel
					embossed: true ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 10/16/2021 13:25:25'!
drawIconOn: aCanvas
	"Draw my icon."

	self magnifiedIcon ifNotNil: [ :bigIcon |
		aCanvas respondsTo: #image:multipliedBy:at: ::
			ifTrue: [
				aCanvas
					image: bigIcon
					multipliedBy: self iconColor
					at: 3 @ (bigIcon extent y // 2) ]
			ifFalse: [
				aCanvas
					image: bigIcon
					at: 3 @ (bigIcon extent y // 2) ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 7/22/2021 21:14:09'!
drawOn: aCanvas

	self isRoundButton
		ifTrue: [
			self
				drawRoundLookOn: aCanvas;
				drawIconOn: aCanvas 			 ]
		ifFalse: [
			self 
				draw3DLookOn: aCanvas;
				drawIconOn: aCanvas 
			 ].
	self drawDisabledIndicationOn: aCanvas! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 6/18/2021 10:28:38'!
drawRegularLabelOn: aCanvas

	| w f center x y  availableW l labelMargin |
	self updateLabelFormModel.
	self magnifiedIcon
		ifNil: [ ^ super drawRegularLabelOn: aCanvas ]
		ifNotNil: [ :bigIcon | | iconWidth |

			f _ self fontToUse.
			center _ extent // 2.
			center _ (center x + ((iconWidth _ bigIcon width) / 2)) @ center y.

			label ifNotNil: [
				labelMargin _ 4.
				w _ f widthOfString: label.
				availableW _ extent x - labelMargin - labelMargin - 1 - iconWidth.
				availableW >= w
					ifTrue: [
						x _ center x - (w // 2).
						l _ label ]
					ifFalse: [
						x _ labelMargin.
						l _ label squeezedTo: (label size * availableW / w) rounded ].
				y _ center y - (f lineSpacing // 2).
				self isPressed ifTrue: [
					x _ x + 1.
					y _ y + 1 ].
				aCanvas
					drawString: l
					at: x@y
					font: f
					color: Theme current buttonLabel ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 7/22/2021 21:19:33'!
iconColor

	^ self isPressed
		ifTrue: [ Color gray: 0.75 ]
		ifFalse: [
			self mouseIsOver
				ifTrue: [ Color gray: 0.75 ]
				ifFalse: [ Color white ]]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'drawing' stamp: 'KLG 6/18/2021 10:28:38'!
magnifiedIcon
	| factor magnifiedExtent w h |

	icon ifNil: [ ^nil ].
	magnifiedIcon ifNil: [
		magnifiedIcon _ icon.
		w _ icon width.
		h _ icon height.
		w*h = 0 ifFalse: [
			factor _ 0.5 * extent x / w min: 0.5 * extent y / h.
			factor = 1.0 ifFalse: [
				magnifiedExtent _ (icon extent * factor) rounded.
				magnifiedIcon _ icon magnifyTo: magnifiedExtent ]]].
	^magnifiedIcon! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
actionArguments
	"Answer the value of actionArguments"

	^ actionArguments! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
actionArguments: anObject
	"Set the value of actionArguments"

	actionArguments _ anObject asArray! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
enabledArgument: anArgument
	"Set one argument for the enabled selector."

	self enabledArguments: { anArgument }! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
enabledArguments
	"Answer the arguments for the enabled selector."

	^ enabledArguments ifNil: [ #() ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
enabledArguments: aCollection
	"Set the arguments for the enabled selector."

	enabledArguments _ aCollection asArray! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
enabledSelector
	"Answer the value of enabledSelector"

	^ enabledSelector! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
enabledSelector: anObject
	"Set the value of enabledSelector"

	enabledSelector _ anObject.
	isEnabled _ nil! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
getStateSelectorArguments: anObject
	"Set the value of getStateSelectorArguments"

	getStateSelectorArguments _ anObject! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
isEnabled
	"Answer true if we are enabled"

	^ isEnabled ifNil: [
		enabledSelector ifNil: [ ^ true ].
		isEnabled _ self model 
			perform: enabledSelector
			withArguments: self enabledArguments ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
isEnabled: anObject
	"Set the value of isEnabled"

	isEnabled _ anObject! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
labelSelector
	"Answer the value of labelSelector"

	^ labelSelector! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
labelSelector: anObject
	"Set the value of labelSelector"

	labelSelector _ anObject.
	label _  nil! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
performAction
	"Inform the model that this button has been pressed. "

	self isEnabled 
		ifFalse: [
			self flashWith: `Color red` ]
		ifTrue: [
			actionSelector ifNotNil: [
				actionArguments
					ifNil: [ self target perform: actionSelector ]
					ifNotNil: [ self target 
						perform: actionSelector withArguments: actionArguments ] ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
target
	"Answer the value of target"

	^ target ifNil: [ self model ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'accessing' stamp: 'KLG 6/18/2021 10:28:38'!
target: anObject
	"Set the value of target"

	target _ anObject! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'initialization' stamp: 'KLG 6/18/2021 10:28:38'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	super model: anObject.
	getStateSelector ifNil: [
		anObject ifNotNil: [
			enabledSelector 
				ifNotNil: [ anObject addDependent: self ]
				ifNil: [ labelSelector ifNotNil: [ anObject addDependent: self ] ] ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'initialization' stamp: 'KLG 6/18/2021 10:28:38'!
model: anObject stateGetter: getStateSel action: actionSel label: aString
	"Initialize the whole button"
	
	| labelToSet |
	labelToSet _ labelSelector ifNotNil: [ nil ] ifNil: [ aString ].
	super model: anObject stateGetter: getStateSel action: actionSel label: labelToSet.
	self updateLabelFormModel
	
		
	! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'initialization' stamp: 'KLG 6/18/2021 10:28:38'!
model: anObject 
	stateGetter: getStateSel stateGetterArguments: stateGetterArguments
	action: actionSel actionArguments: someActionArguments
	label: aString
	"Initialize the whole button.
	
	This time doing a bit more."

	getStateSelectorArguments _ stateGetterArguments.
	actionArguments _ someActionArguments.
	self model: anObject stateGetter: getStateSel action: actionSel label: aString.
		
	! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'private' stamp: 'KLG 11/29/2021 07:44:54'!
getBooleanState
	"Get a boolean state, translate nil to false."

	^ self getState ifNil: [ false ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'private' stamp: 'KLG 6/18/2021 10:28:38'!
getModelState
	"Answer the result of sending the receiver's model the getStateSelector message."

	^ getStateSelector 
		ifNil: [ false ]
		ifNotNil: [
			getStateSelectorArguments 
				ifNotNil: [ model
						perform: getStateSelector
						withArguments: getStateSelectorArguments ]
				ifNil: [ super getModelState ] :: ifNil: [ false ] ]! !

!(Modules>>#Buttons>>#PluggableButtonMorph) methodsFor: 'testing' stamp: 'KLG 11/29/2021 07:45:23'!
isPressed
	"Answer true if the button is pressed."

	^ isPressed | self getBooleanState! !
