'From Haver 5.0 [latest update: #4637] on 17 June 2021 at 7:28:36 pm'!
'Description I provide a grid-layout morph.'!
!provides: 'GridLayout' 1 6!
SystemOrganization addCategory: 'GridLayout'!


!moduleCreation: GridLayout!
Modules newEnvironment: #GridLayout!

!interfacesOf: GridLayout!
Modules environment: #GridLayout ::
	interface: #UTI exporting: #(#GridLayoutMorph #CellMorph ) ::
	interface: #SPI aliasFor: #API!


!classDefinition: (Modules>>#GridLayout>>#CellMorph) category: 'GridLayout'!
WidgetMorph subclass: #CellMorph
	instanceVariableNames: 'contents textComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridLayout'
	inModule: #GridLayout!
!classDefinition: (Modules>>#GridLayout>>#CellMorph) class category: 'GridLayout'!
(Modules>>#GridLayout>>#CellMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#GridLayout>>#GridLayoutMorph) category: 'GridLayout'!
WidgetMorph subclass: #GridLayoutMorph
	instanceVariableNames: 'submorphCreator numberOfRows numberOfColumns rowHeights columnWidths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridLayout'
	inModule: #GridLayout!
!classDefinition: (Modules>>#GridLayout>>#GridLayoutMorph) class category: 'GridLayout'!
(Modules>>#GridLayout>>#GridLayoutMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) category: 'GridLayout'!
(Modules>>#GridLayout>>#GridLayoutMorph) subclass: #GridLayoutWithHeadingsMorph
	instanceVariableNames: 'headingMorphCreator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridLayout'
	inModule: #GridLayout!
!classDefinition: (Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) class category: 'GridLayout'!
(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#GridLayout>>#AbstractSpreadSheetMorph) category: 'GridLayout'!
(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) subclass: #AbstractSpreadSheetMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridLayout'
	inModule: #GridLayout!
!classDefinition: (Modules>>#GridLayout>>#AbstractSpreadSheetMorph) class category: 'GridLayout'!
(Modules>>#GridLayout>>#AbstractSpreadSheetMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#GridLayout>>#SampleSpreadSheetMorph) category: 'GridLayout'!
(Modules>>#GridLayout>>#AbstractSpreadSheetMorph) subclass: #SampleSpreadSheetMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridLayout'
	inModule: #GridLayout!
!classDefinition: (Modules>>#GridLayout>>#SampleSpreadSheetMorph) class category: 'GridLayout'!
(Modules>>#GridLayout>>#SampleSpreadSheetMorph) class
	instanceVariableNames: ''!


!(Modules>>#GridLayout>>#CellMorph) commentStamp: '<historical>' prior: 0!
I am a morph that is used to display the formated cell contents.!

!(Modules>>#GridLayout>>#GridLayoutMorph) commentStamp: '<historical>' prior: 0!
I am a gridlayout morph.!

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) commentStamp: '<historical>' prior: 0!
I am a grid layout morph with headings.!

!(Modules>>#GridLayout>>#AbstractSpreadSheetMorph) commentStamp: '<historical>' prior: 0!
I am the abstract super class of all spread sheet morphs.!

!(Modules>>#GridLayout>>#SampleSpreadSheetMorph) commentStamp: '<historical>' prior: 0!
I am a sample morph for a spreadsheet.!

!(Modules>>#GridLayout>>#CellMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/17/2021 15:14:50'!
initializedInstance
	"Answer an instance of the receiver which in some sense is initialized.  In the case of Morphs, this will yield an instance that can be attached to the Hand after having received the same kind of basic initialization that would be obtained from an instance chosen from the 'new morph' menu.
	Return nil if the receiver is reluctant for some reason to return such a thing"

	^ self contents: 'A grid cell'! !

!(Modules>>#GridLayout>>#CellMorph) methodsFor: 'accessing' stamp: 'KLG 6/17/2021 15:52:52'!
contents: aTextOrString
	"Set the conents, which may be ether text or string."

	contents _ aTextOrString.
	textComposition _ TextComposition new.
	textComposition
		setModel: (TextModel withText: contents asText);
		extentForComposing: 9999999@9999999.
	textComposition composeAll.
	self needsRedraw: true.
	owner ifNotNil: [ 
			owner 
				 submorphNeedsRedraw: true;
				someSubmorphPositionOrExtentChanged ]! !

!(Modules>>#GridLayout>>#CellMorph) methodsFor: 'initialization' stamp: 'KLG 6/17/2021 15:03:43'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!(Modules>>#GridLayout>>#CellMorph) methodsFor: 'initialization' stamp: 'KLG 6/17/2021 15:37:47'!
defaultColor

	^ `Color lightGray`! !

!(Modules>>#GridLayout>>#CellMorph) methodsFor: 'drawing' stamp: 'KLG 6/17/2021 15:11:37'!
drawOn: aCanvas

	| r |
	aCanvas
		fillRectangle:  (r _ self morphLocalBounds) color: self color;
		textComposition: textComposition
		bounds: (r insetBy: 4)
		color: `Color black`
		selectionColor: (Theme current textHighlightFocused: false)! !

!(Modules>>#GridLayout>>#CellMorph) methodsFor: 'geometry' stamp: 'KLG 6/17/2021 15:35:32'!
borderSeparation

	^ `6 @ 6`! !

!(Modules>>#GridLayout>>#CellMorph) methodsFor: 'geometry' stamp: 'KLG 6/17/2021 15:35:32'!
minimumExtent
	"Answer the minimum extent."

	^ textComposition usedExtent + self borderSeparation! !

!(Modules>>#GridLayout>>#CellMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/17/2021 15:03:43'!
contents: aString
	"Make up and return a HoverHelp for morph."
	^self new contents: aString! !

!(Modules>>#GridLayout>>#CellMorph) class methodsFor: 'new-morph participation' stamp: 'KLG 6/17/2021 15:06:21'!
categoryInNewMorphMenu
	^ 'Tools'! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout-properties' stamp: 'KLG 6/14/2021 14:44:18'!
layoutSpec
	"Layout specific. Return the layout spec describing where the
	receiver should appear in a proportional layout"

	layoutSpec ifNotNil: [ :ls | ^ ls ].
	layoutSpec _ LayoutSpec useAll.
	layoutSpec morph: self.

	^ layoutSpec ! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'accessing' stamp: 'KLG 6/14/2021 14:48:06'!
numberOfColumns
	"Answer the value of numberOfColumns"

	^ numberOfColumns! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'accessing' stamp: 'KLG 6/14/2021 18:49:04'!
numberOfColumns: anObject
	"Set the value of numberOfColumns"

	columnWidths _ Array new: (numberOfColumns _ anObject).
	self tryCreateSubMorphs! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'accessing' stamp: 'KLG 6/14/2021 14:48:06'!
numberOfRows
	"Answer the value of numberOfRows"

	^ numberOfRows! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'accessing' stamp: 'KLG 6/14/2021 18:49:14'!
numberOfRows: anObject
	"Set the value of numberOfRows"

	rowHeights _ Array new: (numberOfRows _ anObject).
	self tryCreateSubMorphs! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'submorphs' stamp: 'KLG 6/16/2021 14:17:17'!
dispatchingSubmorphCreator
	"I am the submurph creator that is used by the submorph creation method.
	
	Subclasses may override me, to achive different results for special cells like headings."

	^ submorphCreator! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'submorphs' stamp: 'KLG 6/17/2021 12:45:07'!
hasSubMorphCreator
	"Answer true if I have a (valid) sub morph creation block."

	^ submorphCreator notNil! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'submorphs' stamp: 'KLG 6/14/2021 16:54:16'!
submorphCreator
	"Answer the value of submorphCreator"

	^ submorphCreator! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'submorphs' stamp: 'KLG 6/14/2021 18:49:19'!
submorphCreator: anObject
	"Set the value of submorphCreator"

	submorphCreator _ anObject.
	self tryCreateSubMorphs! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'submorphs' stamp: 'KLG 6/17/2021 12:45:26'!
tryCreateSubMorphs
	"Try to create mu submorphs."

	self hasSubMorphCreator ifFalse: [ ^ self ].
	numberOfRows ifNil: [ ^ self ].
	numberOfColumns ifNil: [ ^ self ].
	self rowAndColumnNumbersDo: [ :rowNumber :columnNumber |
		self addMorphBack: (self dispatchingSubmorphCreator valueWithPossibleArgument: rowNumber and: columnNumber) ]! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'initialization' stamp: 'KLG 6/14/2021 14:51:54'!
initialize
	"Create all my submoprhs."

	super initialize.
	self tryCreateSubMorphs! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/14/2021 22:06:12'!
computeColumnStarts
	"Compute the y positions each column starts.."

	| current |
	current _ self separationWidth >> 1.
	^ columnWidths collect: [ :width | | last |
		last _ current.
		current _ width + current + self separationWidth.
		last ]! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/15/2021 12:56:38'!
computeColumnWidths
	"Compute the column width."

	1 to: numberOfColumns do: [ :columnNumber | 	| columnWidth |
		columnWidth _ 0.
		self submorphsInColumn:  columnNumber do: [ :submorph | | morphWidth |
			morphWidth _ submorph minimumLayoutWidth.
			columnWidth _ columnWidth max: morphWidth ].
		columnWidths at: columnNumber put: columnWidth ]
						! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/15/2021 12:56:55'!
computeRowHeights
	"Compute the row heights."

	1 to: numberOfRows do: [ :rowNumber | 	| rowHeight |
		rowHeight _ 0.
		self submorphsInRow: rowNumber do: [ :submorph | | morphHeight |
			morphHeight _ submorph minimumLayoutHeight.
			rowHeight _ rowHeight max: morphHeight ].
		rowHeights at: rowNumber put: rowHeight ]
						! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/14/2021 22:06:25'!
computeRowStarts
	"Compute the x positions each row starts.."

	| current |
	current _ self separationHeight >> 2.
	^ rowHeights collect: [ :height | | last |
		last _ current.
		current _ height + current + self separationHeight.
		last ]! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/15/2021 13:24:19'!
layoutSubmorphs
	"Compute a new layout based on the given layout bounds."

	| rowStarts columStarts |
	submorphs isEmpty ifTrue: [
		self layoutNeeded: false.
		^self].
	self 
		morphExtent: (self morphExtent max: self minimumExtent);
		computeRowHeights;
		computeColumnWidths.
	rowStarts _ self computeRowStarts.
	columStarts _ self computeColumnStarts.
	self rowAndColumnNumbersWithSubmorphsDo: [ :rowIndex :columnIndex :submorph | | newExtent |
		(newExtent _ (columnWidths at: columnIndex) @ (rowHeights at: rowIndex)) =
			submorph morphExtent  ifFalse: [ 
				submorph morphExtent:				newExtent ].
		submorph morphPosition: 
			(columStarts at: columnIndex ) @ (rowStarts at: rowIndex) ].
	self layoutNeeded: false.! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/14/2021 21:57:01'!
separationHeight

	^ 10! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'layout' stamp: 'KLG 6/14/2021 21:56:28'!
separationWidth

	^ 20! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'enumeration' stamp: 'KLG 6/14/2021 16:30:28'!
rowAndColumnNumbersDo: aBlock
	"Enumerate over the row and column numbers."

	1 to: numberOfRows do: [ :rowNumber |
		1 to: numberOfColumns do: [ :columnNumber |
			aBlock value: rowNumber value: columnNumber ] ]! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'enumeration' stamp: 'KLG 6/14/2021 16:53:29'!
rowAndColumnNumbersWithSubmorphsDo: aBlock
	"Enumerate over the row and column numbers and submorphs."

	| rowNumber columnNumber | 
	rowNumber _ columnNumber _ 1.
	self submorphsDo: [ :submorph |
		aBlock value: rowNumber value: columnNumber value: submorph.
		columnNumber _ columnNumber + 1.
		columnNumber > numberOfColumns ifTrue: [
			columnNumber _ 1.
			rowNumber _ rowNumber + 1 ] ]
			! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'enumeration' stamp: 'KLG 6/15/2021 13:17:59'!
submorphsInColumn: aColumnNumber do: aBlock
	"Enumerate over the submorphs in the column denoted by aColumnNumber."

	aColumnNumber to: self submorphCount by: numberOfColumns do: [ :index |
		aBlock valueWithPossibleArgument: (submorphs at: index) and:  index ]
			! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'enumeration' stamp: 'KLG 6/14/2021 18:56:29'!
submorphsInRow: aRowNumber do: aBlock
	"Enumerate over the submorphs in the row denoted by aRowNumber."

	| startIndex |
	startIndex _ numberOfColumns * (aRowNumber  -  1) + 1.
	startIndex to: startIndex + (numberOfColumns - 1) do: [ :index |
		aBlock valueWithPossibleArgument: (submorphs at: index) and: index ]
			! !

!(Modules>>#GridLayout>>#GridLayoutMorph) methodsFor: 'geometry testing' stamp: 'KLG 6/14/2021 21:54:57'!
clipsSubmorphs
	"Answer true if we clip the shape of our submorphs to our own.
	Answer true only when clipping by the canvas is needed.
	Morphs that can guarantee that submorphs don't protrude and answer false to 
	#submorphsMightProtrude should answer false for better performance.
	Note: Currently we are limited to only one clipping morph in an owner / submorph chain.
	See #clipsSubmorphsReally"

	^ true! !

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) methodsFor: 'instance creation' stamp: 'KLG 6/16/2021 14:25:28'!
headingMorphClass
	"Answer the morph class for headings."

	^ self class headingMorphClass! !

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) methodsFor: 'submorphs' stamp: 'KLG 6/16/2021 14:41:26'!
defaultHeadingMorphCreator
	"Answer the default block that creates the heading morphs."
	
	^ [ :rowNumber :columnNumber |
		self headingMorphClass contents:
			(String streamContents: [ :stream |
				self
					printTextForRowNumber: rowNumber
					andColumnNumber: columnNumber
					on: stream ]) ].! !

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) methodsFor: 'submorphs' stamp: 'KLG 6/16/2021 14:23:15'!
dispatchingSubmorphCreator
	"I am the subsmurph creator that is used by the submorph creation method.
	
	Subclasses may override me, to achive different results for special cells like headings."

	^ [ :rowNumber :columnNumber |
		rowNumber = 1 or: [ columnNumber = 1 ] ::
			ifTrue: [
				self headingMorphCreator
					valueWithPossibleArgument: rowNumber
					and:  columnNumber ]
			ifFalse: [
				self submorphCreator
					valueWithPossibleArgument: rowNumber - 1 
					and: columnNumber - 1 ] ]! !

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) methodsFor: 'submorphs' stamp: 'KLG 6/16/2021 14:06:37'!
headingMorphCreator
	"Answer the block that creates the heading morph.
	
	Use a suitable default if nil."

	^ headingMorphCreator ifNil: [ self defaultHeadingMorphCreator ]! !

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) methodsFor: 'submorphs' stamp: 'KLG 6/16/2021 14:39:21'!
printTextForRowNumber: aRowNumber andColumnNumber: aColumnNumber on: aStream
	"comment stating purpose of message"

	aRowNumber = 1 and: [ aColumnNumber = 1 ] :: ifTrue: [ ^ self ].
			aColumnNumber = 1 ifTrue: [
				aStream nextPut: $R.
				aRowNumber printOn: aStream base: 10  length: 2 padded: true ].
			aRowNumber = 1 ifTrue: [
				aStream nextPut: $C.
				aColumnNumber printOn: aStream base: 10 length: 2 padded: true ]! !

!(Modules>>#GridLayout>>#GridLayoutWithHeadingsMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/16/2021 14:25:19'!
headingMorphClass
	"Answer the morph class for headings."

	^ LabelMorph! !

!(Modules>>#GridLayout>>#AbstractSpreadSheetMorph) methodsFor: 'instance creation' stamp: 'KLG 6/17/2021 18:54:02'!
cellMorphClass
	"Answer the class of the cell subsmurphs."

	^ self class cellMorphClass! !

!(Modules>>#GridLayout>>#AbstractSpreadSheetMorph) methodsFor: 'initialization' stamp: 'KLG 6/17/2021 18:54:11'!
defaultColor

	^ Color darkGray! !

!(Modules>>#GridLayout>>#AbstractSpreadSheetMorph) class methodsFor: 'instance creation' stamp: 'KLG 6/17/2021 18:53:54'!
cellMorphClass
	"Answer the class of the cell subsmurphs."

	^ CellMorph! !

!(Modules>>#GridLayout>>#SampleSpreadSheetMorph) methodsFor: 'submorphs' stamp: 'KLG 6/17/2021 12:46:09'!
hasSubMorphCreator
	"Answer true if I have a (valid) sub morph creation block."

	"I have a default subsmurph creation block."
	^ true! !

!(Modules>>#GridLayout>>#SampleSpreadSheetMorph) methodsFor: 'submorphs' stamp: 'KLG 6/17/2021 18:51:43'!
submorphCreator
	"Answer the value of submorphCreator"

	^ super submorphCreator ifNil: [
		[ :rowNumber :columnNumber |
			self cellMorphClass contents: (
				Text streamContents: [ :stream |
					rowNumber printOn: stream base: 10 length:2 padded: true.
					stream nextPutAll: '@'bold.
					columnNumber printOn: stream base: 10  length: 2  padded: true ]) ] ]! !
