'From Haver 6.0 [latest update: #5087] on 25 February 2022 at 10:53:39 am'!
'Description '!
!provides: 'Accessability' 1 5!



!Preferences class methodsFor: '*Accessability-get/set' stamp: 'KLG 8/13/2021 16:14:23'!
defaultHoverHelpBorder
	"Reset the hover help border to the default value."

	self hoverHelpBorderWidth: 6! !

!Preferences class methodsFor: '*Accessability-standard queries'!
hoverHelpBorderWidth
	^ self
		valueOfFlag: #hoverHelpBorderWidth
		ifAbsent: [ 6 ].! !

!Preferences class methodsFor: '*Accessability-get/set' stamp: 'KLG 8/13/2021 16:07:52'!
hoverHelpBorderWidth: aWidth
	"Set the hover help border width."

	self setPreference: #hoverHelpBorderWidth toValue: (aWidth min: 100 max: 0)
! !

!Preferences class methodsFor: '*Accessability-get/set' stamp: 'KLG 8/13/2021 16:09:46'!
mediumHoverHelpBorder
	"Hover help a big border."

	self hoverHelpBorderWidth: 6
! !

!Preferences class methodsFor: '*Accessability-get/set' stamp: 'KLG 8/6/2021 21:42:59'!
noHoverHelpBorder
	"Hover help should have no border."

	self hoverHelpBorderWidth: 0
! !

!Preferences class methodsFor: '*Accessability-get/set' stamp: 'KLG 8/13/2021 16:07:32'!
thickHoverHelpBorder
	"Hover help thik border."

	self hoverHelpBorderWidth: 10
! !

!Preferences class methodsFor: '*Accessability-get/set' stamp: 'KLG 8/13/2021 16:10:18'!
thinHoverHelpBorder
	"Hover help thik border."

	self hoverHelpBorderWidth: 2
! !

!HoverHelpMorph methodsFor: '*Accessability-accessing' stamp: 'KLG 8/7/2021 12:17:33'!
contents: aString
	contents _ aString.
	textComposition _ TextComposition new.
	textComposition
		setModel: (TextModel withText: contents asText);
		extentForComposing: 9999999@9999999.
	textComposition composeAll.
	self morphExtent: textComposition usedExtent + 8 + (borderWidth * 2)! !

!HoverHelpMorph methodsFor: '*Accessability-accessing' stamp: 'KLG 2/24/2022 20:16:39'!
contents: aStringOrText wrappedTo: wordWrapWidthOrNil
	"If wordWrapWidthOrNil is nil, don't do wordwrap, and make the morph as wide as needed"

	| width |
	contents _ aStringOrText.
	width _ wordWrapWidthOrNil ifNil: [9999999].
	textComposition _ TextComposition new.
	textComposition
		setModel: (TextModel withText: contents asText);
		extentForComposing: 	width@9999999.
	textComposition composeAll.
	self morphExtent: textComposition usedExtent + 8 + (borderWidth * 2).! !

!HoverHelpMorph methodsFor: '*Accessability-initialization' stamp: 'KLG 8/6/2021 21:29:12'!
defaultBorderWidth
	"answer the default border width for the receiver"
	
	^ Preferences hoverHelpBorderWidth! !

!HoverHelpMorph methodsFor: '*Accessability-drawing' stamp: 'KLG 8/7/2021 11:48:00'!
drawOn: aCanvas
	"Dram the hover help"

	| bounds |
	bounds _ self morphLocalBounds.
	aCanvas
		roundRect: bounds
		color: (borderWidth = 0
			ifTrue: [ self color ]
			ifFalse: [ Theme current hoverHelpBorderColor ])
		radius: 6.
	borderWidth = 0 ifFalse: [
		aCanvas
			roundRect: (bounds insetBy: borderWidth)
			color: self color
			radius: 4 ].
	aCanvas
		textComposition: textComposition
		bounds: (bounds insetBy: borderWidth + 4)
		color: `Color black`
		selectionColor: (Theme current textHighlightFocused: false).! !

!Theme methodsFor: '*Accessability-widget colors' stamp: 'KLG 8/6/2021 21:20:35'!
hoverHelpBorderColor
	"Answer the color for Hover help widgets."

	^ `Color black`! !

!Theme methodsFor: '*Accessability-other options' stamp: 'KLG 8/13/2021 16:05:14'!
hoverHelpBorderWidth
	"Answer the hover help morph's border width."
	
	| borderWidth |
	borderWidth _ Preferences standardListFont pointSize / 11.
	borderWidth _ borderWidth * Theme current hoverHelpBorderWidth + 3.
	^ borderWidth rounded max: 0! !
