'From Haver 5.0 [latest update: #4998] on 9 December 2021 at 2:58:10 pm'!
'Description I provide modifications that support zooming Toplevel windows.'!
!provides: 'MorphZooming' 1 6!
!requires: 'VectorGraphics' 1 266 nil!






!Preferences class methodsFor: '*MorphZooming-queries' stamp: 'KLG 8/25/2021 18:48:43'!
controlVerticalScrollScalesSystemWindow
	"Answer true if the vertical wheel scrolling with the Control key pressed scales the system window."

	^ Smalltalk
		at: #VectorEngineWithPlugin 
		ifPresent: [ :plugin |
			plugin isPluginAvailable
				 ifTrue: [
					self 
						valueOfFlag: #controlVerticalScrollScalesSystemWindow
						ifAbsent: [ true ] ]
				ifFalse: [ false ] ]
		ifAbsent: [ false ].
	! !

!SystemWindow methodsFor: '*MorphZooming-events' stamp: 'KLG 11/29/2021 19:55:34'!
handlesMouseScroll: aMouseScrollEvent
	"Answer true if we want mouse scroll events."
	
	aMouseScrollEvent controlKeyPressed ifFalse: [ 
		"D: Transcript cr; show: 'SW scroll no control key'.
		Transcript cr; show: aMouseScrollEvent buttons."
		^ #(left right) identityIncludes: aMouseScrollEvent direction :: or: [
			super handlesMouseScroll: aMouseScrollEvent ] ].
	^ Preferences controlVerticalScrollScalesSystemWindow! !

!SystemWindow methodsFor: '*MorphZooming-events' stamp: 'KLG 11/29/2021 19:59:20'!
mouseScroll: aMouseScrollEvent localPosition: localEventPosition
	"Handle a mouse scroll event."

	| scaleFactor newScale |
	aMouseScrollEvent controlKeyPressed
		ifTrue: [
			scaleFactor _ aMouseScrollEvent direction
				caseOf: {
					[ #up ] -> [ 1.05 ].
					[ #down ] -> [ `1 / 1.05` ].
					[ #left ] -> [ ^ self ].
					[ #right ] -> [ ^ self ] } ]
		ifFalse: [
			scaleFactor _ aMouseScrollEvent direction
				caseOf: {
					[ #up ] -> [ ^ self ].
					[ #down ] -> [ ^ self ].
					[ #left ] -> [ `1 / 1.05` ].
					[ #right ] -> [ 1.05 ] } ].
	newScale _ self scale * scaleFactor min: 5 max: 0.5.
	(newScale - 1) abs < 0.01
		ifTrue: [ newScale _ 1 ].
	self scale: (newScale)! !

!KeyboardEvent methodsFor: '*MorphZooming-testing' stamp: 'KLG 12/9/2021 09:54:28'!
isScaleOneWindowShortcut

	^ (self rawMacOptionKeyPressed or: [ self controlKeyPressed ])
		and: [self keyCharacter = $0]! !

!KeyboardEvent methodsFor: '*MorphZooming-actions' stamp: 'KLG 11/29/2021 19:47:49'!
scaleOneCurrentWindowOf: aMorph

	aMorph owningWindow ifNotNil: [ :w |
		w scale: 1 ]! !

!KeyboardEvent methodsFor: '*MorphZooming-dispatching' stamp: 'KLG 8/16/2021 22:03:01'!
sendEventTo: aMorph
	"Dispatch the receiver into anObject"
	type == #keystroke ifTrue: [
		self isFindClassShortcut
			ifTrue: [ ^ Preferences classFinder value ].
		self isCloseWindowShortcut
			ifTrue: [ ^ self closeCurrentWindowOf: aMorph ].
		self isScaleOneWindowShortcut ifTrue: [
			^ self scaleOneCurrentWindowOf: aMorph ].
		^ aMorph processKeystroke: self ].
	type == #keyDown ifTrue: [
		^ aMorph processKeyDown: self ].
	type == #keyUp ifTrue: [ 
		^ aMorph processKeyUp: self ].
	^ super sendEventTo: aMorph.! !
